# FALLEN KNIGHT




scoreboard players add @s Boss_Sb_4 1



# Elevate the boss
execute as @s[scores={Boss_Sb_4=1}] run effect give @s levitation 2 50 true

# Invulnerable to prevent damage from fall damage
execute as @s[scores={Boss_Sb_4=1}] run data merge entity @s {Invulnerable:1b}

# VFX From casting ability
execute as @s[scores={Boss_Sb_4=1}] run playsound minecraft:item.crossbow.shoot ambient @a[distance=..15] ~ ~1 ~ 1 0
execute as @s[scores={Boss_Sb_4=1}] run playsound minecraft:entity.warden.sonic_charge ambient @a[distance=..15] ~ ~1 ~ 1 2
execute as @s[scores={Boss_Sb_4=1}] run particle cloud ~ ~1 ~ 0 0 0 0.25 15 force @a 
execute as @s[scores={Boss_Sb_4=1}] run particle explosion ~ ~1 ~ 0 0 0 0 3 force @a 

# Summons the landing marker
# This is where the boss will land 
execute as @s[scores={Boss_Sb_4=1}] run execute as @a[distance=..30,limit=1,sort=nearest] at @s run summon marker ~ ~ ~ {Tags:[BOSS_FallenKnight_DeadlySlamMarker]}

execute as @s[scores={Boss_Sb_4=2}] run tp @s ~ ~ ~ facing entity @e[tag=BOSS_FallenKnight_DeadlySlamMarker,distance=..50,limit=1,sort=nearest]

# Look at nearest player
execute as @s[scores={Boss_Sb_4=15}] run data merge entity @s {NoAI:1b}
# execute as @s[scores={Boss_Sb_4=15}] run function faction:look_at_ally


# Fix the entity's rotation of view
execute as @s[scores={Boss_Sb_4=25}] run tp @s ~ ~ ~ ~ 0

# Start moving towards the landing marker
# Will stop once Landing Marker is nearby
# Will not work if theres a block in front
execute as @s[scores={Boss_Sb_4=20}] run data merge entity @s {NoGravity:1b}
execute as @s[scores={Boss_Sb_4=25..45}] unless entity @e[tag=BOSS_FallenKnight_DeadlySlamMarker,distance=..3.5] run function faction:entity_cmds/boss/fallen_knight/deadly_slam/move_forward
execute as @s[scores={Boss_Sb_4=25..45}] positioned ~ ~-3.50 ~ unless entity @e[tag=BOSS_FallenKnight_DeadlySlamMarker,distance=..3.5] run execute positioned ~ ~3.50 ~ run function faction:entity_cmds/boss/fallen_knight/deadly_slam/move_forward
execute as @s[scores={Boss_Sb_4=25..45}] positioned ~ ~-7.00 ~ unless entity @e[tag=BOSS_FallenKnight_DeadlySlamMarker,distance=..3.5] run execute positioned ~ ~7.00 ~ run function faction:entity_cmds/boss/fallen_knight/deadly_slam/move_forward
execute as @s[scores={Boss_Sb_4=25..45}] positioned ~ ~-10.5 ~ unless entity @e[tag=BOSS_FallenKnight_DeadlySlamMarker,distance=..3.5] run execute positioned ~ ~10.50 ~ run function faction:entity_cmds/boss/fallen_knight/deadly_slam/move_forward

# execute as @s[scores={Boss_Sb_4=25..45}] run tp @s ^ ^ ^.5

execute as @s[scores={Boss_Sb_4=45}] run data merge entity @s {NoGravity:0b}
execute as @s[scores={Boss_Sb_4=45}] run data merge entity @s {NoAI:0b}
execute as @s[scores={Boss_Sb_4=46..}] at @s[nbt={OnGround:1b}] run function faction:entity_cmds/boss/fallen_knight/deadly_slam/end

# Restart Cycle
execute as @s[scores={Boss_Sb_4=80..}] run function faction:entity_cmds/boss/fallen_knight/deadly_slam/end

