# VERDANT WIZARD
#
# Every 30s, summon a magic spell book, whenever a spellbook is nearby,
# boss will be inmune to damage:
#   - The spells books will target the player and choose between 
#       random attacks:
#           1. Fire bolt: A fireball that leaves a fire spot on collision.
#           2. Frost bolt: An ice ball that freezes the player on collision.
#           3. Shock bolt: A ball of energy that weakens the player on collision.
#           
# Every 60s, it will cast one of two random spells:
#
#   - Mana Barrage: Seeking projectile that upon collision with a player will attempt
#                to heal the boss.
#
#   - Boss will summon a spell book when player does a lot of damage
#
#   
#   OLD CONCEPTS:
#
#   - Teleport to itself
#   - Tempest: Summons a breeze that pushes player back, levitation is applied, deals 
#              damage to players who aren't on the ground. (Breeze with scale 20, Invulnerable)
#
#   - Blizzard: Summons an ice storm that slows down players, players who don't move for
#               3s will be frozen and be damaged.
#
#   - Meteor Strike: Summons a meteor shower that deal massive damage to players.
#               
#   - Eldritch Seal: Stops the player from receiving any positive effects



scoreboard players add @s Boss_Sb_Shield 1

# Spawn Spell Books
execute as @s[scores={Boss_Sb_Shield=1}] run playsound minecraft:entity.evoker.prepare_summon ambient @a[distance=..15] ~ ~1 ~ 10 0.85
# execute as @s[scores={Boss_Sb_Shield=1}] run playsound minecraft:entity.elder_guardian.ambient ambient @a[distance=..15] ~ ~1 ~ 10 2
execute as @s[scores={Boss_Sb_Shield=20}] run playsound minecraft:entity.elder_guardian.ambient ambient @a[distance=..15] ~ ~1 ~ 10 2
execute as @s[scores={Boss_Sb_Shield=40}] run playsound minecraft:entity.elder_guardian.ambient ambient @a[distance=..15] ~ ~1 ~ 10 2
execute as @s[scores={Boss_Sb_Shield=60}] run playsound minecraft:entity.elder_guardian.ambient ambient @a[distance=..15] ~ ~1 ~ 10 2
execute as @s[scores={Boss_Sb_Shield=80}] run playsound minecraft:entity.elder_guardian.ambient ambient @a[distance=..15] ~ ~1 ~ 10 2
execute as @s[scores={Boss_Sb_Shield=100}] run playsound minecraft:entity.elder_guardian.ambient ambient @a[distance=..15] ~ ~1 ~ 10 2
execute as @s[scores={Boss_Sb_Shield=120}] run playsound minecraft:entity.elder_guardian.ambient ambient @a[distance=..15] ~ ~1 ~ 10 2
execute as @s[scores={Boss_Sb_Shield=140}] run playsound minecraft:entity.elder_guardian.ambient ambient @a[distance=..15] ~ ~1 ~ 10 2

execute as @s[scores={Boss_Sb_Shield=1}] run data merge entity @s {Invulnerable:1b}
execute as @s[scores={Boss_Sb_Shield=1}] run effect give @s resistance 5 1 false

execute as @s[scores={Boss_Sb_Shield=1..}] run particle enchanted_hit ~ ~1 ~ 0.525 0.975 0.55 0.15 15





# Restart Cycle
execute as @s[scores={Boss_Sb_Shield=160..}] run function faction:entity_cmds/boss/verdant_wizard/shield_cmds/end
